Index: sansview/test/_THETA_weights.txt
===================================================================
--- sansview/test/_THETA_weights.txt	(revision 5de248a7d93b53f9650ab13b71f33a4f0ac304e8)
+++ sansview/test/_THETA_weights.txt	(revision 5de248a7d93b53f9650ab13b71f33a4f0ac304e8)
@@ -0,0 +1,1000 @@
+0  1
+0.00157237  0.999999
+0.00314474  0.999995
+0.00471712  0.999989
+0.00628949  0.99998
+0.00786186  0.999969
+0.00943423  0.999955
+0.0110066  0.999939
+0.012579  0.999921
+0.0141514  0.9999
+0.0157237  0.999876
+0.0172961  0.99985
+0.0188685  0.999822
+0.0204408  0.999791
+0.0220132  0.999758
+0.0235856  0.999722
+0.025158  0.999684
+0.0267303  0.999643
+0.0283027  0.9996
+0.0298751  0.999554
+0.0314474  0.999506
+0.0330198  0.999455
+0.0345922  0.999402
+0.0361646  0.999346
+0.0377369  0.999288
+0.0393093  0.999228
+0.0408817  0.999165
+0.0424541  0.999099
+0.0440264  0.999031
+0.0455988  0.998961
+0.0471712  0.998888
+0.0487435  0.998813
+0.0503159  0.998735
+0.0518883  0.998655
+0.0534607  0.998572
+0.055033  0.998487
+0.0566054  0.998399
+0.0581778  0.998309
+0.0597502  0.998217
+0.0613225  0.998122
+0.0628949  0.998024
+0.0644673  0.997924
+0.0660396  0.997822
+0.067612  0.997717
+0.0691844  0.99761
+0.0707568  0.9975
+0.0723291  0.997388
+0.0739015  0.997273
+0.0754739  0.997156
+0.0770462  0.997036
+0.0786186  0.996914
+0.080191  0.99679
+0.0817634  0.996663
+0.0833357  0.996534
+0.0849081  0.996402
+0.0864805  0.996268
+0.0880529  0.996131
+0.0896252  0.995992
+0.0911976  0.99585
+0.09277  0.995706
+0.0943423  0.99556
+0.0959147  0.995411
+0.0974871  0.995259
+0.0990595  0.995106
+0.100632  0.994949
+0.102204  0.994791
+0.103777  0.99463
+0.105349  0.994466
+0.106921  0.9943
+0.108494  0.994132
+0.110066  0.993961
+0.111638  0.993788
+0.113211  0.993612
+0.114783  0.993434
+0.116356  0.993254
+0.117928  0.993071
+0.1195  0.992885
+0.121073  0.992697
+0.122645  0.992507
+0.124217  0.992315
+0.12579  0.99212
+0.127362  0.991922
+0.128935  0.991722
+0.130507  0.99152
+0.132079  0.991315
+0.133652  0.991108
+0.135224  0.990899
+0.136796  0.990687
+0.138369  0.990473
+0.139941  0.990256
+0.141514  0.990037
+0.143086  0.989815
+0.144658  0.989592
+0.146231  0.989365
+0.147803  0.989137
+0.149375  0.988906
+0.150948  0.988672
+0.15252  0.988436
+0.154092  0.988198
+0.155665  0.987957
+0.157237  0.987714
+0.15881  0.987469
+0.160382  0.987221
+0.161954  0.986971
+0.163527  0.986718
+0.165099  0.986464
+0.166671  0.986206
+0.168244  0.985947
+0.169816  0.985685
+0.171389  0.98542
+0.172961  0.985154
+0.174533  0.984884
+0.176106  0.984613
+0.177678  0.984339
+0.17925  0.984063
+0.180823  0.983784
+0.182395  0.983504
+0.183968  0.98322
+0.18554  0.982935
+0.187112  0.982647
+0.188685  0.982357
+0.190257  0.982064
+0.191829  0.981769
+0.193402  0.981472
+0.194974  0.981172
+0.196547  0.98087
+0.198119  0.980566
+0.199691  0.980259
+0.201264  0.97995
+0.202836  0.979639
+0.204408  0.979325
+0.205981  0.979009
+0.207553  0.978691
+0.209126  0.978371
+0.210698  0.978048
+0.21227  0.977723
+0.213843  0.977395
+0.215415  0.977065
+0.216987  0.976733
+0.21856  0.976399
+0.220132  0.976062
+0.221705  0.975723
+0.223277  0.975382
+0.224849  0.975038
+0.226422  0.974692
+0.227994  0.974344
+0.229566  0.973994
+0.231139  0.973641
+0.232711  0.973286
+0.234283  0.972929
+0.235856  0.972569
+0.237428  0.972207
+0.239001  0.971843
+0.240573  0.971477
+0.242145  0.971108
+0.243718  0.970738
+0.24529  0.970364
+0.246862  0.969989
+0.248435  0.969611
+0.250007  0.969231
+0.25158  0.968849
+0.253152  0.968465
+0.254724  0.968078
+0.256297  0.96769
+0.257869  0.967298
+0.259441  0.966905
+0.261014  0.96651
+0.262586  0.966112
+0.264159  0.965712
+0.265731  0.96531
+0.267303  0.964905
+0.268876  0.964498
+0.270448  0.96409
+0.27202  0.963678
+0.273593  0.963265
+0.275165  0.96285
+0.276738  0.962432
+0.27831  0.962012
+0.279882  0.96159
+0.281455  0.961166
+0.283027  0.960739
+0.284599  0.960311
+0.286172  0.95988
+0.287744  0.959447
+0.289317  0.959012
+0.290889  0.958574
+0.292461  0.958135
+0.294034  0.957693
+0.295606  0.957249
+0.297178  0.956803
+0.298751  0.956355
+0.300323  0.955905
+0.301895  0.955452
+0.303468  0.954998
+0.30504  0.954541
+0.306613  0.954082
+0.308185  0.953621
+0.309757  0.953158
+0.31133  0.952692
+0.312902  0.952225
+0.314474  0.951756
+0.316047  0.951284
+0.317619  0.95081
+0.319192  0.950334
+0.320764  0.949856
+0.322336  0.949376
+0.323909  0.948894
+0.325481  0.948409
+0.327053  0.947923
+0.328626  0.947435
+0.330198  0.946944
+0.331771  0.946451
+0.333343  0.945956
+0.334915  0.94546
+0.336488  0.944961
+0.33806  0.94446
+0.339632  0.943957
+0.341205  0.943451
+0.342777  0.942944
+0.34435  0.942435
+0.345922  0.941924
+0.347494  0.94141
+0.349067  0.940895
+0.350639  0.940378
+0.352211  0.939858
+0.353784  0.939337
+0.355356  0.938813
+0.356929  0.938287
+0.358501  0.93776
+0.360073  0.93723
+0.361646  0.936699
+0.363218  0.936165
+0.36479  0.935629
+0.366363  0.935092
+0.367935  0.934552
+0.369508  0.93401
+0.37108  0.933467
+0.372652  0.932921
+0.374225  0.932373
+0.375797  0.931824
+0.377369  0.931272
+0.378942  0.930718
+0.380514  0.930163
+0.382086  0.929605
+0.383659  0.929046
+0.385231  0.928485
+0.386804  0.927921
+0.388376  0.927356
+0.389948  0.926789
+0.391521  0.926219
+0.393093  0.925648
+0.394665  0.925075
+0.396238  0.9245
+0.39781  0.923923
+0.399383  0.923344
+0.400955  0.922763
+0.402527  0.922181
+0.4041  0.921596
+0.405672  0.92101
+0.407244  0.920421
+0.408817  0.919831
+0.410389  0.919239
+0.411962  0.918644
+0.413534  0.918048
+0.415106  0.917451
+0.416679  0.916851
+0.418251  0.916249
+0.419823  0.915646
+0.421396  0.91504
+0.422968  0.914433
+0.424541  0.913824
+0.426113  0.913213
+0.427685  0.9126
+0.429258  0.911986
+0.43083  0.911369
+0.432402  0.910751
+0.433975  0.910131
+0.435547  0.909509
+0.43712  0.908885
+0.438692  0.908259
+0.440264  0.907632
+0.441837  0.907003
+0.443409  0.906372
+0.444981  0.905739
+0.446554  0.905104
+0.448126  0.904468
+0.449698  0.90383
+0.451271  0.90319
+0.452843  0.902548
+0.454416  0.901904
+0.455988  0.901259
+0.45756  0.900612
+0.459133  0.899963
+0.460705  0.899313
+0.462277  0.89866
+0.46385  0.898006
+0.465422  0.89735
+0.466995  0.896693
+0.468567  0.896033
+0.470139  0.895372
+0.471712  0.89471
+0.473284  0.894045
+0.474856  0.893379
+0.476429  0.892711
+0.478001  0.892042
+0.479574  0.89137
+0.481146  0.890697
+0.482718  0.890023
+0.484291  0.889346
+0.485863  0.888668
+0.487435  0.887988
+0.489008  0.887307
+0.49058  0.886624
+0.492153  0.885939
+0.493725  0.885253
+0.495297  0.884565
+0.49687  0.883875
+0.498442  0.883184
+0.500014  0.882491
+0.501587  0.881796
+0.503159  0.8811
+0.504732  0.880402
+0.506304  0.879702
+0.507876  0.879001
+0.509449  0.878298
+0.511021  0.877594
+0.512593  0.876888
+0.514166  0.87618
+0.515738  0.875471
+0.517311  0.874761
+0.518883  0.874048
+0.520455  0.873334
+0.522028  0.872619
+0.5236  0.871902
+0.525172  0.871183
+0.526745  0.870463
+0.528317  0.869741
+0.529889  0.869018
+0.531462  0.868293
+0.533034  0.867567
+0.534607  0.866839
+0.536179  0.866109
+0.537751  0.865379
+0.539324  0.864646
+0.540896  0.863912
+0.542468  0.863177
+0.544041  0.86244
+0.545613  0.861701
+0.547186  0.860961
+0.548758  0.86022
+0.55033  0.859477
+0.551903  0.858732
+0.553475  0.857986
+0.555047  0.857239
+0.55662  0.85649
+0.558192  0.85574
+0.559765  0.854988
+0.561337  0.854234
+0.562909  0.85348
+0.564482  0.852724
+0.566054  0.851966
+0.567626  0.851207
+0.569199  0.850447
+0.570771  0.849685
+0.572344  0.848921
+0.573916  0.848157
+0.575488  0.847391
+0.577061  0.846623
+0.578633  0.845854
+0.580205  0.845084
+0.581778  0.844312
+0.58335  0.843539
+0.584923  0.842765
+0.586495  0.841989
+0.588067  0.841212
+0.58964  0.840433
+0.591212  0.839654
+0.592784  0.838872
+0.594357  0.83809
+0.595929  0.837306
+0.597502  0.836521
+0.599074  0.835734
+0.600646  0.834946
+0.602219  0.834157
+0.603791  0.833366
+0.605363  0.832575
+0.606936  0.831781
+0.608508  0.830987
+0.61008  0.830191
+0.611653  0.829394
+0.613225  0.828596
+0.614798  0.827796
+0.61637  0.826996
+0.617942  0.826193
+0.619515  0.82539
+0.621087  0.824585
+0.622659  0.823779
+0.624232  0.822972
+0.625804  0.822164
+0.627377  0.821354
+0.628949  0.820543
+0.630521  0.819731
+0.632094  0.818918
+0.633666  0.818104
+0.635238  0.817288
+0.636811  0.816471
+0.638383  0.815653
+0.639956  0.814833
+0.641528  0.814013
+0.6431  0.813191
+0.644673  0.812368
+0.646245  0.811544
+0.647817  0.810719
+0.64939  0.809893
+0.650962  0.809065
+0.652535  0.808236
+0.654107  0.807407
+0.655679  0.806576
+0.657252  0.805743
+0.658824  0.80491
+0.660396  0.804076
+0.661969  0.80324
+0.663541  0.802404
+0.665114  0.801566
+0.666686  0.800727
+0.668258  0.799887
+0.669831  0.799046
+0.671403  0.798204
+0.672975  0.797361
+0.674548  0.796517
+0.67612  0.795671
+0.677692  0.794825
+0.679265  0.793977
+0.680837  0.793129
+0.68241  0.792279
+0.683982  0.791429
+0.685554  0.790577
+0.687127  0.789724
+0.688699  0.78887
+0.690271  0.788016
+0.691844  0.78716
+0.693416  0.786303
+0.694989  0.785445
+0.696561  0.784586
+0.698133  0.783727
+0.699706  0.782866
+0.701278  0.782004
+0.70285  0.781141
+0.704423  0.780277
+0.705995  0.779413
+0.707568  0.778547
+0.70914  0.77768
+0.710712  0.776813
+0.712285  0.775944
+0.713857  0.775075
+0.715429  0.774204
+0.717002  0.773333
+0.718574  0.77246
+0.720147  0.771587
+0.721719  0.770713
+0.723291  0.769838
+0.724864  0.768962
+0.726436  0.768085
+0.728008  0.767207
+0.729581  0.766329
+0.731153  0.765449
+0.732726  0.764569
+0.734298  0.763687
+0.73587  0.762805
+0.737443  0.761922
+0.739015  0.761038
+0.740587  0.760154
+0.74216  0.759268
+0.743732  0.758381
+0.745305  0.757494
+0.746877  0.756606
+0.748449  0.755717
+0.750022  0.754827
+0.751594  0.753937
+0.753166  0.753045
+0.754739  0.752153
+0.756311  0.75126
+0.757883  0.750366
+0.759456  0.749472
+0.761028  0.748576
+0.762601  0.74768
+0.764173  0.746783
+0.765745  0.745886
+0.767318  0.744987
+0.76889  0.744088
+0.770462  0.743188
+0.772035  0.742287
+0.773607  0.741386
+0.77518  0.740484
+0.776752  0.739581
+0.778324  0.738677
+0.779897  0.737773
+0.781469  0.736868
+0.783041  0.735962
+0.784614  0.735055
+0.786186  0.734148
+0.787759  0.73324
+0.789331  0.732332
+0.790903  0.731422
+0.792476  0.730513
+0.794048  0.729602
+0.79562  0.728691
+0.797193  0.727779
+0.798765  0.726866
+0.800338  0.725953
+0.80191  0.725039
+0.803482  0.724125
+0.805055  0.723209
+0.806627  0.722294
+0.808199  0.721377
+0.809772  0.72046
+0.811344  0.719543
+0.812917  0.718624
+0.814489  0.717705
+0.816061  0.716786
+0.817634  0.715866
+0.819206  0.714945
+0.820778  0.714024
+0.822351  0.713102
+0.823923  0.71218
+0.825495  0.711257
+0.827068  0.710334
+0.82864  0.70941
+0.830213  0.708485
+0.831785  0.70756
+0.833357  0.706634
+0.83493  0.705708
+0.836502  0.704781
+0.838074  0.703854
+0.839647  0.702926
+0.841219  0.701998
+0.842792  0.701069
+0.844364  0.70014
+0.845936  0.69921
+0.847509  0.69828
+0.849081  0.697349
+0.850653  0.696418
+0.852226  0.695486
+0.853798  0.694554
+0.855371  0.693621
+0.856943  0.692688
+0.858515  0.691754
+0.860088  0.69082
+0.86166  0.689886
+0.863232  0.688951
+0.864805  0.688016
+0.866377  0.68708
+0.86795  0.686144
+0.869522  0.685207
+0.871094  0.68427
+0.872667  0.683333
+0.874239  0.682395
+0.875811  0.681457
+0.877384  0.680518
+0.878956  0.679579
+0.880529  0.678639
+0.882101  0.6777
+0.883673  0.67676
+0.885246  0.675819
+0.886818  0.674878
+0.88839  0.673937
+0.889963  0.672995
+0.891535  0.672053
+0.893108  0.671111
+0.89468  0.670169
+0.896252  0.669226
+0.897825  0.668282
+0.899397  0.667339
+0.900969  0.666395
+0.902542  0.665451
+0.904114  0.664506
+0.905686  0.663561
+0.907259  0.662616
+0.908831  0.661671
+0.910404  0.660725
+0.911976  0.659779
+0.913548  0.658833
+0.915121  0.657886
+0.916693  0.65694
+0.918265  0.655993
+0.919838  0.655045
+0.92141  0.654098
+0.922983  0.65315
+0.924555  0.652202
+0.926127  0.651254
+0.9277  0.650305
+0.929272  0.649357
+0.930844  0.648408
+0.932417  0.647459
+0.933989  0.646509
+0.935562  0.64556
+0.937134  0.64461
+0.938706  0.64366
+0.940279  0.64271
+0.941851  0.641759
+0.943423  0.640809
+0.944996  0.639858
+0.946568  0.638907
+0.948141  0.637956
+0.949713  0.637005
+0.951285  0.636054
+0.952858  0.635103
+0.95443  0.634151
+0.956002  0.633199
+0.957575  0.632247
+0.959147  0.631295
+0.96072  0.630343
+0.962292  0.629391
+0.963864  0.628438
+0.965437  0.627486
+0.967009  0.626533
+0.968581  0.625581
+0.970154  0.624628
+0.971726  0.623675
+0.973298  0.622722
+0.974871  0.621769
+0.976443  0.620816
+0.978016  0.619863
+0.979588  0.618909
+0.98116  0.617956
+0.982733  0.617003
+0.984305  0.616049
+0.985877  0.615096
+0.98745  0.614142
+0.989022  0.613189
+0.990595  0.612235
+0.992167  0.611282
+0.993739  0.610328
+0.995312  0.609374
+0.996884  0.608421
+0.998456  0.607467
+1.00003  0.606513
+1.0016  0.605559
+1.00317  0.604606
+1.00475  0.603652
+1.00632  0.602698
+1.00789  0.601745
+1.00946  0.600791
+1.01104  0.599838
+1.01261  0.598884
+1.01418  0.597931
+1.01575  0.596977
+1.01732  0.596024
+1.0189  0.59507
+1.02047  0.594117
+1.02204  0.593164
+1.02361  0.59221
+1.02519  0.591257
+1.02676  0.590304
+1.02833  0.589351
+1.0299  0.588398
+1.03148  0.587446
+1.03305  0.586493
+1.03462  0.58554
+1.03619  0.584588
+1.03777  0.583635
+1.03934  0.582683
+1.04091  0.581731
+1.04248  0.580779
+1.04406  0.579827
+1.04563  0.578875
+1.0472  0.577923
+1.04877  0.576972
+1.05034  0.57602
+1.05192  0.575069
+1.05349  0.574118
+1.05506  0.573167
+1.05663  0.572216
+1.05821  0.571266
+1.05978  0.570315
+1.06135  0.569365
+1.06292  0.568415
+1.0645  0.567465
+1.06607  0.566515
+1.06764  0.565566
+1.06921  0.564617
+1.07079  0.563667
+1.07236  0.562718
+1.07393  0.56177
+1.0755  0.560821
+1.07708  0.559873
+1.07865  0.558925
+1.08022  0.557977
+1.08179  0.557029
+1.08336  0.556082
+1.08494  0.555135
+1.08651  0.554188
+1.08808  0.553241
+1.08965  0.552295
+1.09123  0.551349
+1.0928  0.550403
+1.09437  0.549457
+1.09594  0.548512
+1.09752  0.547567
+1.09909  0.546622
+1.10066  0.545678
+1.10223  0.544733
+1.10381  0.543789
+1.10538  0.542846
+1.10695  0.541902
+1.10852  0.540959
+1.11009  0.540017
+1.11167  0.539074
+1.11324  0.538132
+1.11481  0.53719
+1.11638  0.536249
+1.11796  0.535308
+1.11953  0.534367
+1.1211  0.533426
+1.12267  0.532486
+1.12425  0.531546
+1.12582  0.530607
+1.12739  0.529668
+1.12896  0.528729
+1.13054  0.527791
+1.13211  0.526853
+1.13368  0.525915
+1.13525  0.524978
+1.13683  0.524041
+1.1384  0.523104
+1.13997  0.522168
+1.14154  0.521232
+1.14311  0.520297
+1.14469  0.519362
+1.14626  0.518427
+1.14783  0.517493
+1.1494  0.516559
+1.15098  0.515626
+1.15255  0.514693
+1.15412  0.513761
+1.15569  0.512828
+1.15727  0.511897
+1.15884  0.510965
+1.16041  0.510035
+1.16198  0.509104
+1.16356  0.508174
+1.16513  0.507245
+1.1667  0.506316
+1.16827  0.505387
+1.16985  0.504459
+1.17142  0.503531
+1.17299  0.502604
+1.17456  0.501677
+1.17613  0.500751
+1.17771  0.499825
+1.17928  0.4989
+1.18085  0.497975
+1.18242  0.497051
+1.184  0.496127
+1.18557  0.495203
+1.18714  0.494281
+1.18871  0.493358
+1.19029  0.492436
+1.19186  0.491515
+1.19343  0.490594
+1.195  0.489674
+1.19658  0.488754
+1.19815  0.487835
+1.19972  0.486916
+1.20129  0.485997
+1.20286  0.48508
+1.20444  0.484163
+1.20601  0.483246
+1.20758  0.48233
+1.20915  0.481414
+1.21073  0.480499
+1.2123  0.479585
+1.21387  0.478671
+1.21544  0.477758
+1.21702  0.476845
+1.21859  0.475933
+1.22016  0.475021
+1.22173  0.47411
+1.22331  0.473199
+1.22488  0.472289
+1.22645  0.47138
+1.22802  0.470471
+1.2296  0.469563
+1.23117  0.468656
+1.23274  0.467749
+1.23431  0.466842
+1.23588  0.465937
+1.23746  0.465032
+1.23903  0.464127
+1.2406  0.463223
+1.24217  0.46232
+1.24375  0.461417
+1.24532  0.460515
+1.24689  0.459614
+1.24846  0.458713
+1.25004  0.457813
+1.25161  0.456913
+1.25318  0.456014
+1.25475  0.455116
+1.25633  0.454219
+1.2579  0.453322
+1.25947  0.452425
+1.26104  0.45153
+1.26262  0.450635
+1.26419  0.44974
+1.26576  0.448847
+1.26733  0.447954
+1.2689  0.447061
+1.27048  0.44617
+1.27205  0.445279
+1.27362  0.444389
+1.27519  0.443499
+1.27677  0.44261
+1.27834  0.441722
+1.27991  0.440834
+1.28148  0.439947
+1.28306  0.439061
+1.28463  0.438176
+1.2862  0.437291
+1.28777  0.436407
+1.28935  0.435524
+1.29092  0.434641
+1.29249  0.433759
+1.29406  0.432878
+1.29563  0.431998
+1.29721  0.431118
+1.29878  0.430239
+1.30035  0.429361
+1.30192  0.428483
+1.3035  0.427607
+1.30507  0.42673
+1.30664  0.425855
+1.30821  0.424981
+1.30979  0.424107
+1.31136  0.423234
+1.31293  0.422361
+1.3145  0.42149
+1.31608  0.420619
+1.31765  0.419749
+1.31922  0.41888
+1.32079  0.418011
+1.32237  0.417144
+1.32394  0.416277
+1.32551  0.41541
+1.32708  0.414545
+1.32865  0.41368
+1.33023  0.412817
+1.3318  0.411953
+1.33337  0.411091
+1.33494  0.41023
+1.33652  0.409369
+1.33809  0.408509
+1.33966  0.40765
+1.34123  0.406792
+1.34281  0.405934
+1.34438  0.405078
+1.34595  0.404222
+1.34752  0.403367
+1.3491  0.402512
+1.35067  0.401659
+1.35224  0.400806
+1.35381  0.399955
+1.35538  0.399104
+1.35696  0.398253
+1.35853  0.397404
+1.3601  0.396556
+1.36167  0.395708
+1.36325  0.394861
+1.36482  0.394015
+1.36639  0.39317
+1.36796  0.392326
+1.36954  0.391482
+1.37111  0.39064
+1.37268  0.389798
+1.37425  0.388957
+1.37583  0.388117
+1.3774  0.387278
+1.37897  0.38644
+1.38054  0.385602
+1.38212  0.384765
+1.38369  0.38393
+1.38526  0.383095
+1.38683  0.382261
+1.3884  0.381428
+1.38998  0.380595
+1.39155  0.379764
+1.39312  0.378934
+1.39469  0.378104
+1.39627  0.377275
+1.39784  0.376447
+1.39941  0.37562
+1.40098  0.374794
+1.40256  0.373969
+1.40413  0.373145
+1.4057  0.372322
+1.40727  0.371499
+1.40885  0.370677
+1.41042  0.369857
+1.41199  0.369037
+1.41356  0.368218
+1.41514  0.3674
+1.41671  0.366583
+1.41828  0.365767
+1.41985  0.364952
+1.42142  0.364137
+1.423  0.363324
+1.42457  0.362512
+1.42614  0.3617
+1.42771  0.360889
+1.42929  0.36008
+1.43086  0.359271
+1.43243  0.358463
+1.434  0.357656
+1.43558  0.35685
+1.43715  0.356045
+1.43872  0.355241
+1.44029  0.354438
+1.44187  0.353636
+1.44344  0.352834
+1.44501  0.352034
+1.44658  0.351235
+1.44815  0.350436
+1.44973  0.349639
+1.4513  0.348842
+1.45287  0.348047
+1.45444  0.347252
+1.45602  0.346458
+1.45759  0.345666
+1.45916  0.344874
+1.46073  0.344083
+1.46231  0.343293
+1.46388  0.342505
+1.46545  0.341717
+1.46702  0.34093
+1.4686  0.340144
+1.47017  0.339359
+1.47174  0.338575
+1.47331  0.337792
+1.47489  0.33701
+1.47646  0.336229
+1.47803  0.335449
+1.4796  0.33467
+1.48117  0.333891
+1.48275  0.333114
+1.48432  0.332338
+1.48589  0.331563
+1.48746  0.330789
+1.48904  0.330016
+1.49061  0.329244
+1.49218  0.328472
+1.49375  0.327702
+1.49533  0.326933
+1.4969  0.326165
+1.49847  0.325398
+1.50004  0.324631
+1.50162  0.323866
+1.50319  0.323102
+1.50476  0.322339
+1.50633  0.321577
+1.50791  0.320816
+1.50948  0.320055
+1.51105  0.319296
+1.51262  0.318538
+1.51419  0.317781
+1.51577  0.317025
+1.51734  0.31627
+1.51891  0.315516
+1.52048  0.314763
+1.52206  0.314011
+1.52363  0.31326
+1.5252  0.31251
+1.52677  0.311761
+1.52835  0.311013
+1.52992  0.310266
+1.53149  0.30952
+1.53306  0.308775
+1.53464  0.308032
+1.53621  0.307289
+1.53778  0.306547
+1.53935  0.305806
+1.54092  0.305067
+1.5425  0.304328
+1.54407  0.30359
+1.54564  0.302854
+1.54721  0.302118
+1.54879  0.301384
+1.55036  0.300651
+1.55193  0.299918
+1.5535  0.299187
+1.55508  0.298456
+1.55665  0.297727
+1.55822  0.296999
+1.55979  0.296272
+1.56137  0.295546
+1.56294  0.294821
+1.56451  0.294097
+1.56608  0.293374
+1.56766  0.292652
+1.56923  0.291931
+1.5708  0.291211